<!-- todo.inc
     This file contains XML macrotags and associated logic to simplify the way
     action items can be completed by user defined pages.
-->
<rb:macrotag name="rbm:todo-prime">
  var rb$params;

  if (rb$params==null)
    rb$params = rb.page.formdata();

  var rb$admin  = extauth.isIn('hradmin,super');
  var memberid  = -1;
  var userName  = extauth.sessionUser;
  var anEmployee;
  var thisAction;
  var Goto = (rb$params.returnURL==null?rb.page.attribute('goto'):rb$params.returnURL);

  if (rb$admin) {
    if (rb$params.memberid!=null)
	    // Get the user information from the member ID.
	     memberid = parseInt(rb$params.memberid);
  }
  else {
    // Use the authenticated user.
    memberid = userName;
  }
  var todoID = parseInt(rb$params.todoID);
  if (!isNaN(todoID)) {
    thisAction = new Action(todoID);

    // check to see whether any actions are to be applied this time.
    if (thisAction.nodeData.status=='Outstanding') {
      for (var item in rb$params) {
        if (item.indexOf('rbcmd-todo-')==0) {
          var outcome = item.slice(11);
          rb.debug.write("Outcome is "+outcome+"<br>");
          // rb.debug.write("Goto = '"+Goto+"'<br>\n");
          if (thisAction.makeComplete(outcome))
            Util.httpRedirect(Goto);
        }
      }
    }
  }

</rb:macrotag>

<rb:macrotag name="rbm:todo">
  // Put up a 'complete' button. There are *TWO* attributes:
  //   outcome    : which is the name of the outcome this button will build.
  //   adminonly  : Only display if logged in as admin user.
  // The button is only shown if the item is *not* complete.
  var attribs = rb.page.attributes();

  if (thisAction.nodeData.status=='Outstanding') {
    // Find the outcome...
    if (attribs.outcome==null || attribs.outcome=='')
      rb.debug.error('Missing "outcome" attribute in rbm:todo tag');
    else {
      for (var i=0;i<thisAction.nodeData.outcome.length;i++) {
        var act = thisAction.nodeData.outcome[i];
        if (act.name==attribs.outcome) {
          // This is the one.
          rb.page.write('<input type="submit" name="rbcmd-todo-'+act.name+'" value="'+(act.label!=null?act.label:act.name)+'">');
          break;
        }
      }
    }
  }
</rb:macrotag>
