// WEBINFO
// rb.debug.trace(true);
if (rb$command==null) {
   // Create the communities.
   var Communities = SysData.Communities;

   if (Communities==null) {
      var Communities     = new Object;
      SysData.Communities = Communities;
   }
   if (SysData.contactEmail==null)
     SysData.contactEmail = 'stevec@pmw.co.uk';

   if (SysData.adminEmail==null)
     SysData.adminEmail = 'admin@pmw.co.uk';

   if (SysData.regEmail==null)
     SysData.regEmail = 'stevec@pmw.co.uk';

   // Make a named community. If the community does not exist then create it. If it does
   // retrieve the ID. In either case return the ID of the community.
   function MakeCommunity(record) {
   var commData = {uName:record.uName, name:record.name, description:record.desc};
   var id = rb.contact.createCommunity(commData);

      rb.page.write("<li>Creating community:"+commData.uName+"</li>");

      if (id==-1) {
         // Community already exists so go get it.
         var it = rb.contact.communityInfo(-1,record.uName);

         if (it!=null) {
	         id = it.ID;
         }
      }
      record.ID = id;
      return id;
   }
   // Attempt to create the basic structure if it doesn't exist.
   if (SysData.RootCats==null)
      SysData.RootCats = new Object;

   rb.page.write("<ul>\n<li>Creating catalogue root nodes.</li>\n");
   SysData.RootCats['Profiles']       = MakeCategory({name:"Profiles",             description:"Large textual/image profile information for individuals"});
   SysData.RootCats['News']           = MakeCategory({name:"News",                 description:"Issued News Reports"});
   SysData.RootCats['Documents']      = MakeCategory({name:"Documents",            description:"General Documents"});
   SysData.RootCats['ArchDocs']       = MakeCategory({name:"ArchDocs",             description:"Old Versions of Documents"}, SysData.RootCats['Documents']);
   SysData.RootCats['Released']       = MakeCategory({name:"Released",             description:"Formal Released Documents"}, SysData.RootCats['Documents']);
   SysData.RootCats['Catalogue']      = MakeCategory({name:"Catalogue",            description:"Hierarchical catalogue"});
   SysData.RootCats['GenCat']         = MakeCategory({name:"GenCat",               description:"Generic Catalogue"},SysData.RootCats['Catalogue']);
   SysData.RootCats['Events']         = MakeCategory({name:"Events",               description:"Events"});
   SysData.RootCats['EventsAgenda']   = MakeCategory({name:"Agenda",               description:"Agenda"},SysData.RootCats['Events']);
   SysData.RootCats['EventsActions']  = MakeCategory({name:"Actions",              description:"Actions"},SysData.RootCats['Events']);
   SysData.RootCats['EventsDeleted']  = MakeCategory({name:"Deleted",              description:"Deleted Events"},SysData.RootCats['Events']);
   SysData.RootCats['EventsDocs']     = MakeCategory({name:"Documents",            description:"Event related documents"},SysData.RootCats['Events']);
   SysData.RootCats['WG']             = MakeCategory({name:"WG",                   description:"Central point for WG activity"});
   SysData.RootCats['WebPages']       = MakeCategory({name:"WebPages",             description:"Modifiable/modified web pages."});
   SysData.RootCats['FAQ']            = MakeCategory({name:"FAQ",                  description:"Frequently Asked Questions."});
   SysData.RootCats['Glossary']       = MakeCategory({name:"Glossary",             description:"Defintion of terms."});
   SysData.RootCats['NewsLetters']    = MakeCategory({name:"NewsLetters",          description:"Every news letter ever created."});
   SysData.RootCats['Images']         = MakeCategory({name:"Images",               description:"Images for web documents"});
   SysData.RootCats['XPRLrel']        = MakeCategory({name:"XPRL Releases",        description:"References for all news items in XPRL encoding."});
   SysData.RootCats['XPRLfb']         = MakeCategory({name:"XPRL Feedback",        description:"References to all feedback response."});
   SysData.RootCats['XPRLfb-src']     = MakeCategory({name:"XPRL Feedback Sent",   description:"References to all feedback responses SENT."});
   rb.debug.write("<hr>");


   var id;
   for (var comm in Community) {
      id = MakeCommunity(Community[comm]);
      Communities[Community[comm].name] = id;
   }
   // Make the news letter community separately - it's not directly used for access 
   // control and we don't want it cluttering up security.inc!
   id = MakeCommunity({uName:"newsletter", name:"newsletter", desc:"Distribution list for people to remove the monthly newsletter."});
   if (id>0)
     Communities['newsletter'] = id;

   dumpObj(Communities, "Communities");

   var tmp, nodeId;

   function CreateUser(data) {
      // Create the admin superuser.
      var user = new Member;

      rb.page.write("<li>Creating user '"+data.uName+"'</li>\n");
      user.uName = data.uName;
      user.ID    = -1;
      user.get();
      if (user.ID<0) {
	      // User does NOT exist - so create.
        user.first_name = data.name?data.name:'';
        user.initial = data.initial?data.initial:'';
        user.surname = data.surname?data.surname:'';
	      user.create();

	      if (user.ID<0 )
		      rb.debug.error("Couldn't create '"+data.uName+"' user.");
	      else
		      // Set the password to 'password'.
		      rb.contact.setPassword(user.ID, data.password);
      }

      rb.page.write("<li>Linking '"+data.uName+"' to communities</li>\n");
      // Make sure the admin user is associated with the super-user communtiy.
      
      if (data.communities) {
         for (var com=0;com<data.communities.length;com++) {
            rb.page.write("<li>Linking '"+data.uName+"'to community:"+data.communities[com].uName+"</li>\n");
            rb.contact.link(user.ID, data.communities[com].ID);
         }
      }
      return user;
   }
   function createOU(data, parent) {
      // Check to make sure the top level 'organisations' OU exists.
      var ID;

      if (SysData.OU==null)
        SysData.OU = {};

      var OUInfo = rb.contact.OUInfo(-1, data.uName);
      if (OUInfo==null) {
        // OK - doesn't exist. Need to create the top level customer OU.
        rb.page.write("<li>Creating OU '"+data.uName+"' - it wasn't found in the search!");
        OUInfo = {uName:data.uName, name:data.name, description:data.description};

        ID = rb.contact.createOU(OUInfo);
        if (ID>0) {
           OUInfo.ID = ID;
           SysData.OU[data.uName] = data.ID;
        }
      }
      else {
         rb.page.write("<li>OU '"+data.uName+"' already exists - ID="+OUInfo.ID);
         SysData.OU[data.uName] = ID = OUInfo.ID;
      }
      if (OUInfo.parent!=parent) {
         if (OUInfo.parent>=0)
            rb.contact.unlink(ID,it.parent);
         rb.page.write("<li>Linking OU '"+data.uName+"' to parent OU, ID="+parent);
         rb.contact.link(ID, parent);
      }

      if (data.communities) {
         for (var com=0;com<data.communities.length;com++) {
            rb.page.write("<li>Linking OU'"+data.uName+"'to community:"+data.communities[com].uName+"</li>\n");
            rb.contact.link(ID, data.communities[com].ID);
         }
      }
      return ID
   }

   var users = createOU({uName:'users',name:'users',description:"ALL users whether they belong to a registered organisation or not.",communities:[Community.User]}, 0);
   rb.debug.trace(true);
               createOU({uName:'orgs', name:'organisations', description:"Top level OU from which to anchor all customer OUs.",communities:[Community.Corporate]}, users);
   rb.debug.trace(false);

   // Key individuals
   CreateUser({uName:'superuser', name:'Super User',          communities:[Community.Super, Community.Admin], password:'password'});
   CreateUser({uName:'admin',     name:'Site Administrator',  communities:[Community.Admin], password:'password'});
   CreateUser({uName:'xprl-bot',  name:'XPRL Automated Agent',communities:[Community.Admin], password:'xprl-decode'});

   // Now - need to create a file object to hold the menu structure - the file is primed from the contents of '/custom/menus.inc'.
   if (SysData.menu==null)
     SysData.menu = {};

   if (SysData.menu.SysMenu!=null) {
     // There is a file referenced stored for the live system menu. Check to make sure the specified file exists.
     var fileIt = rb.file.get({fileID:SysData.menu.SysMenu, allData:1});
     if (!fileIt.getNextRow()) {
       // File doesn't exist. remove reference and start again.
       delete SysData.menu.SysMenu;
     }
   }
   if (SysData.menu.SysMenu==null) {
     var menuFile = new Binary;
     if (menuFile.load('/custom/defMenu.inc')) {
       // OK - got it. Create a file object and store the ID in the syetm data.
       var id = rb.file.create({name:'Menu Structure', owner:'superuser', description:'Contents of the dynamic menu structure', fileDef:menuFile});
       if (id>0)
         SysData.menu.SysMenu = id;
     }
   }
   if (SysData.menu.SysMenuDraft!=null) {
     // There is a file referenced stored for the live system menu. Check to make sure the specified file exists.
     var fileIt = rb.file.get({fileID:SysData.menu.SysMenuDraft, allData:1});
     if (!fileIt.getNextRow()) {
       // File doesn't exist. remove reference and start again.
       delete SysData.menu.SysMenuDraft;
     }
   }
   if (SysData.menu.SysMenuDraft==null) {
     var menuFile = new Binary;
     if (menuFile.load('/custom/defMenu.inc')) {
       // OK - got it. Create a file object and store the ID in the syetm data.
       var id = rb.file.create({name:'Menu Structure', owner:'superuser', description:'Contents of the dynamic menu structure', fileDef:menuFile});
       if (id>0)
         SysData.menu.SysMenuDraft = id;
     }
   }
   dumpObj(SysData, "SysData");
}

