<rb:script>
   function dumpXml(tag,pref,depth) {
      if (depth==null)
         depth = -1;

	   rb.debug.write('<table border="1">');
	   dumpXmlElement(tag, pref, 0, depth);
	   rb.debug.write("</table>");
   }	

   function dumpXmlElement(tag,pref,level, depth) {
      var x;
      with (rb.debug) {
         if (tag==null) {
            write('<tr><td colspan="3">null</td></tr>');
            return ;
         }
			if (level==10) {
				// Too deep!
			   return;
			}
         level++;

			switch (tag.type) {
			case 'tag':
            write("<TR><TD>"+pref+".name</TD><TD>&lt;"+tag.name+"...&gt;</TD></TR>\n");
            if (tag.parent!=null)
               write("<TR><TD>"+pref+".parent.name</TD><TD>&lt;"+tag.parent.name+"...&gt;</TD></TR>\n");
            write("<TR><TD>"+pref+".length</TD><TD>"+tag.length+"</TD></TR>\n");
            write("<TR><TD>"+pref+".type</TD><TD>"+tag.type+"</TD></TR>\n");
            write("<TR><TD>"+pref+".rb$tagid</TD><TD>"+tag.rb$tagid+"</TD></TR>\n");
            
            for (x in tag.attributes) {
               write("<TR><TD>"+pref+".attributes["+x+"]</TD><TD>"+tag.attributes[x]+"</TD></TR>\n");
            }
            depth--;
            if (depth!=0) {
               for (x=0;x<tag.length;x++) {
                  dumpXmlElement(tag[x], pref+'['+x+']', level+1, depth);
               }
            }
            break;            
			case 'text':
			case 'comment':
			case 'cdata':
			case 'pi':
            write("<TR><TD>"+pref+".text</TD><TD><xmp>"+tag.text+"</xmp></TD></TR>\n");
            write("<TR><TD>"+pref+".type</TD><TD>"+tag.type+"</TD></TR>\n");
            break;
			case 'attrib':
            write("<TR><TD>"+pref+".name</TD><TD><xmp>"+tag.name+"</xmp></TD></TR>\n");
            write("<TR><TD>"+pref+".type</TD><TD>"+tag.type+"</TD></TR>\n");
            write("<TR><TD>"+pref+".parent.name</TD><TD>"+tag.parent.name+"</TD></TR>\n");
            write("<TR><TD>"+pref+".rb$tagid</TD><TD>"+tag.rb$tagid+"</TD></TR>\n");
            break;
			default:
             write('<TR><TD>'+pref+'</TD><TD><i>Illegal Element</i></TD></TR>\n');
				 break;
			}
      }
   }

   function dumpXmlParser(parser) {
      with (rb.debug) {
	      write('<table border="1">');
         if (parser.errors) {
            for (x in parser.errors) {
               write('<TR><TD>parser.errors['+x+']</TD><td><xmp>'+parser.errors[x]+'</xmp></td></TR>\n');
            }
         }
         else
            write('<TR><TD>parser.errors</TD><td><i>No Errors</i></td></TR>\n');
         for (x in parser) {
            if (x!="root" && x!="errors") {
               write('<TR><TD>parser.'+x+'</TD><td>'+parser[x]+'</td></TR>\n');
            }
         }
         dumpXmlElement(parser.root, "parser.root", 0);
	      write("</table>");
      }
   }
   
</rb:script>


