/*********************************************************
Component:    Cafeteria Benefits System - events.
$Id$
**********************************************************
$Log$
**********************************************************
Description
===========
Utilities to manage benefit events. Not a class as such
at the moment this is a collection of functions tied to
the BenEvent object.
**********************************************************
Copyright (c) Redbourne Inc, 2001
**********************************************************/
var BenEvent = new Object;

// Activate
// Set the event state to 'active'. Create a community for the event.
BenEvent.Activate = function(name, sysEvents) {
var event = SysData.events[name];

   if (event==null) {
      // Doesn't exist - so give in and return.
      return false;
   }
   if (event.state == 'tmp' || ((sysEvents==true) && (event.state=="sys"))) {
      // Exists. Needs a community. Check to see whether there is already a community with this name.
      var communities = rb.contact.get([name], {searchCommunity:true, searchIndividual:false, hasNodeID:SysData.Categories.Events});
      if (communities.getNextRow()) {
         // Already exists. Get the community ID.
         event.communityId = communities.ID;
         rb.debug.write("Community for event "+name+" already exists<br />\n");
      }
      else {
         event.communityId = rb.contact.createCommunity({name:name, description:'Benefit Event'});
         if (event.communityId>0){
            if (rb.contact.linkCatNode(event.communityId, SysData.Categories.Events)<0) {
               rb.page.error("Can't link benefit event community into the catalogue.");

               // Delete the community.
               rb.contact.remove(event.communityId);
               return false;
            }
         }
      }

      if (event.communityId<0) {
         rb.page.error("Can't create community for event called '"+name+"'");
         return false;
      }
      // Store the community in the catalogue community place.
      rb.debug.write("Community : "+name+" created for event....");

      // Worked OK - now set the state to 'act'.
      if (event.state!='sys')
         event.state = 'act';
   }
   else {
      // Not in the correct state.
      rb.debug.write("Error - event is in the wrong state : '"+name+"!");
      dumpObj(event,"event");
      dumpObj(SysData,"SysData");
      return false;
   }
   return true;
}




