function CreateEvent(name) {

 rb.page.write("<h3>Creating new event:"+name+"</h3>\n");

 // Create a new event.
 if (name!=null && name.length>=5) {
   if (SysData.events[name]==null) {
      SysData.events[name]=new Object;
      SysData.events[name].state = "tmp";
      SysData.events[name].immediateAllowed = false;
   }
 }
     for (item in SysData.events)
       BenEvent.Activate(item, true);
}

function CreateGrade(name) {

 rb.page.write("<h3>Creating new grade:"+name+"</h3>\n");

 // Create a new grade.
 if (name!=null && name.length>=5) {
   if (SysData.grades[name]==null) {
      SysData.grades[name]=new Object;
      SysData.grades[name].state = "tmp";
   }
 }
}

// Load benefit rules for the initial year from the file system. 
function LoadBF(name) {
 var aParser = new XmlParser;
 var fileData = new Binary;
 if (fileData.load("/custom/"+name+".xml" )) {
   if (aParser.build(fileData.toString())) {
     // OK - have the tree. Find the benefit tag.
     tags = aParser.root.find("benefit", false);

     if (tags==null || tags.length == 0) {
        rb.page.error("XML Benefit description does NOT contain a benefit tag!");
        return false;
     }
     else {
        /*********** Insert full benefit description validation HERE ******************/

        // The catalogue item name is extracted from the benefit 'name' attribute.
        var benefitName = tags[0].attributes.name;

        // Write the benefit description.
        MakeItem({code:benefitName, itemData:fileData.toString()}, "/Benefits/"+SysData.constructYear, true);
     }
   }
 }
 else
   rb.debug.error("Failed to load "+name+" benefit description file");
}

// Load benefit rules for the initial year from the file system. 
function LoadRep(name) {
 var aParser = new XmlParser;
 var fileData = new Binary;
 if (fileData.load("/custom/"+name+".xml" )) {
   if (aParser.build(fileData.toString())) {
     // OK - have the tree. Find the benefit tag.
     tags = aParser.root.find("report", false);

     if (tags==null || tags.length == 0) {
        rb.page.error("XML Report description does NOT contain a report tag!");
        return false;
     }
     else {
        /*********** Insert full benefit description validation HERE ******************/

        // The catalogue item name is extracted from the benefit 'name' attribute.
        var reportName = tags[0].attributes.name;

        // Write the benefit description.
        MakeItem({code:benefitName, itemData:fileData.toString()}, "/Reports/"+SysData.constructYear, true);
     }
   }
 }
 else
   rb.debug.error("Failed to load "+name+" report description file");
}
function CreateUser(data) {
   // Create the admin superuser.
   var user = new Member;

   dumpObj(data,"USER_DATA");

   rb.page.write("<li>Creating user '"+data.uName+"'</li>\n");
   user.uName = data.uName;
   user.ID    = -1;
   user.get();
   if (user.ID<0) {
      // User does NOT exist - so create.
      user.first_name = data.name?data.name:'';
      user.initial = data.initial?data.initial:'';
      user.surname = data.surname?data.surname:'';
      user.create();
      
      if (user.ID<0 )
         rb.debug.error("Couldn't create '"+data.uName+"' user.");
      else
         // Set the password to 'password'.
         rb.contact.setPassword(user.ID, data.password);
   }
   
   rb.page.write("<li>Linking '"+data.uName+"' to communities</li>\n");
   // Make sure the admin user is associated with the super-user communtiy.
   
   if (data.communities) {
      for (var com=0;com<data.communities.length;com++) {
         rb.page.write("<li>Linking '"+data.uName+"'to community:"+data.communities[com].uName+"("+data.communities[com].ID+")</li>\n");
         rb.contact.link(user.ID, data.communities[com].ID);
      }
   }
   return user;
}
function createOU(data, parent) {
   // Check to make sure the top level 'organisations' OU exists.
   var ID;

   if (SysData.OU==null)
     SysData.OU = {};

   var OUInfo = rb.contact.OUInfo(-1, data.uName);
   if (OUInfo==null) {
     // OK - doesn't exist. Need to create the top level customer OU.
     rb.page.write("<li>Creating OU '"+data.uName+"' - it wasn't found in the search!");
     OUInfo = {uName:data.uName, name:data.name, description:data.description};

     ID = rb.contact.createOU(OUInfo);
     if (ID>0) {
        OUInfo.ID = ID;
        SysData.OU[data.uName] = data.ID;
     }
   }
   else {
      rb.page.write("<li>OU '"+data.uName+"' already exists - ID="+OUInfo.ID);
      SysData.OU[data.uName] = ID = OUInfo.ID;
   }
   if (OUInfo.parent!=parent) {
      if (OUInfo.parent>=0)
         rb.contact.unlink(ID,it.parent);
      rb.page.write("<li>Linking OU '"+data.uName+"' to parent OU, ID="+parent);
      rb.contact.link(ID, parent);
   }

   if (data.communities) {
      for (var com=0;com<data.communities.length;com++) {
         rb.page.write("<li>Linking OU'"+data.uName+"'to community:"+data.communities[com].uName+"</li>\n");
         rb.contact.link(ID, data.communities[com].ID);
      }
   }
   return ID
}

