var rb$CSVindex;
var rb$CSVstream;

function startCSV( buffer ) {
   rb$CSVindex = 0;
   rb$CSVstream = buffer;
}


function getCSVrecord() {

  // Here we have a state machine which reads a single line of CSV
	// input from the input stream.

  // It deals with standard comma separated literal strings, as well
	// as more complex MS Excel output which encapsulates strings within
	// fields in double quote characters and may even have embedded
  // newlines within strings.

	var record = [""];
	var START_LINE = 0;
	var END_LINE = 1;
	var NONQUOTE_FIELD = 2;
	var QUOTE_TERM = 3;
	var AFTER_SEPARATOR = 4;
	var QUOTE_FIELD = 5;

	var state = START_LINE;
	var field = 0;

	for(; state != END_LINE && rb$CSVindex < rb$CSVstream.length; rb$CSVindex++) {
    var chr = rb$CSVstream[rb$CSVindex];
		switch (chr){
		case '\n':
		case '\r':    //Line terminator
			if(state == NONQUOTE_FIELD||state == QUOTE_TERM||state == AFTER_SEPARATOR)
				state = END_LINE;
			else if(state != START_LINE)
				record[field] += chr;
			break;
		case ',':
			if(state == NONQUOTE_FIELD || state == QUOTE_TERM || state == AFTER_SEPARATOR ){
				field++;
				// initialise an empty field
				record[field] = "";
				state = AFTER_SEPARATOR;
			}
			else
				record[field] += chr;
			break;
		case '"':
			if(state == AFTER_SEPARATOR || state == START_LINE){
				state = QUOTE_FIELD;
			}
			else if (state == QUOTE_FIELD)
				state = QUOTE_TERM;
			else if (state == QUOTE_TERM){
				record[field] += '"';
				state = QUOTE_FIELD;
			}
			else
				record[field] += chr;
			break;
		default:
			if(state == AFTER_SEPARATOR || state == START_LINE)
				state = NONQUOTE_FIELD;
			else if (state == QUOTE_TERM)
				break;
			record[field] += chr;
			break;
		}
	}

  return (field == 0 && rb$CSVindex >= rb$CSVstream.length) ? null : record;
}
