<!-- General purpose document editor - used for:
  --    New Articles,
  --    WG docs
  --    Anything else we want!
  -- Configured by defining Doc.flags.???? before calling. ???? can be:
  --    keyword     - want keyword field
  ---   summary     - want summary field
  --    status      - want status field
  --    category    - want to select category
  -- Must be included within a formset.
  -->
<rb:script>
  if (Doc.flags==null)
    rb.debug.error("Must define 'Doc.flags' before including this file!");

    // If there is a user ID in the parameter list then get that users record.
    function newsForm(memb, display) {
       rb$data = thisArticle;
       var tag = rb.xml.root.findId("newsForm");

       var oldStatic   = rb$doStaticForm;
       rb$doStaticForm = display;

       tag[0].execute();

       // Restore the static flag.
       rb$doStaticForm = oldStatic;

       // Clear the static 
       rb.page.write(tag[0].bodytext());
    }
</rb:script>
<rb:block rb:id="newsForm">
  <!-- ************************ Form declaration for the News Item ***************************-->
	<table class="TableBdr" cellpadding="2">
  <tr valign="bottom" height="1">
    <td><img src="/images/spacer.gif" width="100" height="1"></td>
    <td><img src="/images/spacer.gif" width="100" height="1"></td>
    <td><img src="/images/spacer.gif" width="100" height="1"></td>
    <td><img src="/images/spacer.gif" width="100" height="1"></td>
  </tr>
  <rb:test expr="Doc.flags.author">
  <rb:true>
    <tr>
      <td width="100" valign="middle" class="HeadCell">Author</td>
      <td width="200" valign="middle" class="HeadCell" colspan="2"><rb:eval expr="aMember.name"/></td>
      <td width="*" valign="middle" class="HeadCell" align="right">
        <input type="submit" name="rbcmd-save" rb:eval="value#thisArticle.ID>0?'Save':'Create'" onClick="return validate();">&nbsp;&nbsp;&nbsp;
      </td>
    </tr>
  </rb:true>
  </rb:test>
  <tr valign="bottom" >
    <td width="100" valign="middle" class="HeadCell">Creation Date</td>
    <td valign="middle" class="HeadCell"  colspan="3"><rb:eval expr="Util.fmtShortDate(thisArticle.created)"/></td>
  </tr>
  <rb:test expr="Doc.flags.category">
  <rb:true>
    <rb:test expr="thisArticle.parent==null">
    <rb:true>
      <tr valign="bottom" >
        <td width="100" valign="middle" class="HeadCell">News Category</td>
        <td valign="middle" class="HeadCell">
          <select name="parent">
            <option rb:eval="value#SysData.RootCats.News">General</option>
            <rb:eval expr="insertCategories()"/>
          </select>
        </td>
        <td width="100" valign="middle" class="HeadCell" align="right">Status&nbsp;</td>
        <td width="100" valign="middle" class="HeadCell">
          <select name="state">
            <rb:repeatfor expr="var status in Doc.allowedStatus">
              <option rb:eval="value#status"><rb:eval expr="status"/></option>
            </rb:repeatfor>
          </select>
        </td>
      </tr>
    </rb:true>
    <rb:false>
      <tr>
        <td width="100" valign="middle" class="HeadCell">News Category</td>
        <td valign="middle" class="HeadCell" colspan="3">
          <rb:script>
             for (var i=0;i<catList.length;i++) {
                if (catList[i].ID == thisArticle.parent) {
                   rb.page.write(catList[i].name);
                   break;
                }
             }
             if (i==catList.length)
               rb.page.write("Unclassified Document");
          </rb:script>
        </td>
      </tr>
    </rb:false>
    </rb:test>
  </rb:true>
  </rb:test>
  <tr>
    <td width="100" valign="middle" class="HeadCell">Title</td>
    <td class="HeadCell" colspan="3"><input type="text" size="70" name="title" value=""/></td>
  </tr>
  <rb:test expr="Doc.flags.keywords">
  <rb:true>
    <tr>
      <td width="100" valign="middle" class="HeadCell">Keywords</td>
      <td class="HeadCell" colspan="3"><input type="text" size="70" name="keywords" value=""/></td>
    </tr>
  </rb:true>
  </rb:test>
  <rb:test expr="Doc.flags.summary">
  <rb:true>
  <tr valign="bottom" >
    <td width="100" valign="middle" class="HeadCell">Summary</td>
    <td valign="middle" class="HeadCell" colspan="3"><textarea name="summary" rows="5" cols="60"><rb:eval expr="rb$data.summary"/></textarea></td>
  </tr>
  </rb:true>
  </rb:test>
  <tr valign="bottom" >
    <td width="100" valign="middle" class="HeadCell">Content</td>
    <td valign="middle" class="HeadCell" colspan="3"><textarea name="content" rows="25" cols="60"><rb:eval expr="rb$data.content"/></textarea></td>
  </tr>
  <rb:test expr="Doc.flags.upload">
  <rb:true>
  <tr valign="bottom" >
    <td width="100" valign="middle" class="HeadCell" colspan="3">...or upload a content file</td>
    <td valign="middle" class="HeadCell"><input type="file" name="content_indir"/></td>
  </tr>
  </rb:true>
  </rb:test>
  <rb:test expr="Doc.flags.refFile">
  <rb:true>
  <tr valign="bottom" >
    <td valign="middle" class="HeadCell" colspan="3">...or reference a file on the server<br>(for large documents)</td>
    <td valign="middle" class="HeadCell"><input type="file" name="content_indir"/></td>
  </tr>
  </rb:true>
  </rb:test>
	</table>
</rb:block>

