<rb:script>
// Check SSL configuration. By default if an 'ssl' attribute appears in the 
// 'rbm:extauth' tag then we must we would insist on an SSL connection for
// authentication. If Config.
var Config;
var enableSSL = ((Config==null || Config.enableSSL) && !rb.debug.test());

// If our stack of extauth objects needs initialising,
// do it at the global level.
	if( typeof(_rb$extauth_array) != "array" ) {
		_rb$extauth_array=new Array;
	}
// A place to cache individualInfo and memberOf results.
	if( typeof(_rb$extauth_cache) != "object" ) {
		_rb$extauth_cache={ii:{}, mo:{}};
	}

// The extauth object holds the current state of affairs.
	if( typeof(extauth) != "object" ) {
		extauth = new Object;
		extauth.sessionData= rb.page.session.read();

// Recover the last-used community if it exists.
		if( extauth.sessionData._rb$login != null && typeof(extauth.sessionData._rb$login.lastCommunity) != "undefined") {
			extauth.sessionComm= extauth.sessionData._rb$login.lastCommunity;
		}
	}
  extauth.isIn = function(commList) {
    return (extauth.sessionAuth && _rb$extauth_isin(extauth.sessionUser, commList)!=null);
  }

	function _rb$extauth_notnull(val) { return ( val != null ? val : "" ) }

// A tagtree regenerator and displayer that is recursion safe.
// ("tag" is local, so regenrate can't destroy it...)
	function _rb$extauth_saferegen(tag) {
		   rb.page.write(tag.execute().bodytext());
	}

// Return the individualInfo data for the currently logged in user (if any). This is preferable to using
// the name and looking up in the contact template because generally the extauth module caches information
// it has already used.
  extauth.userInfo = function() {
  var userInfo;

		if( _rb$extauth_cache.ii[extauth.sessionUser] == null ) {
			userInfo=rb.contact.individualInfo(-1,extauth.sessionUser);
			_rb$extauth_cache.ii[extauth.sessionUser] = userInfo;
		}
    else
			userInfo = _rb$extauth_cache.ii[extauth.sessionUser];

    return userInfo;
  }

// Check if an individual is in a community or OU
	function _rb$extauth_isin( user, comm ) {
		var commlist = comm.split(",");
		if( _rb$extauth_cache.ii[user] == null ) {
			_rb$extauth_indiv=rb.contact.individualInfo(-1,user);
			_rb$extauth_cache.ii[user] = _rb$extauth_indiv;
		} else
			_rb$extauth_indiv = _rb$extauth_cache.ii[user];

		if( _rb$extauth_indiv == null ) {
			// user record vanished!
			return null;
		} else {
			if( comm == "*" )
			    return(user);
			if( _rb$extauth_cache.mo[user] == null ) {
				 // rb.debug.write("<h1>_rb$extauth_indiv.ID="+_rb$extauth_indiv.ID+"</h1>");
   				_rb$extauth_member_arr=rb.contact.memberOf(_rb$extauth_indiv.ID);
				_rb$extauth_cache.mo[user]=_rb$extauth_member_arr;
			} else
				_rb$extauth_member_arr=_rb$extauth_cache.mo[user];

			for( var x in commlist ) {
				for( var y in _rb$extauth_member_arr ) {
					if( _rb$extauth_member_arr[y].uName == commlist[x])
						return commlist[x];
				}
			}
		}
    return null;
	}
</rb:script>

<rb:macrotag name="rbm:extauth">
_rb$extauth_array.push(extauth.toSource());

// Get the parameters passed into the tag.
extauth.attribs = rb.page.attributes();
extauth.sessionComm= extauth.attribs.community == null ? "default" :
extauth.attribs.community;
extauth.sessionMand= extauth.attribs.mandatory == null ? "yes" :
extauth.attribs.mandatory;

if(extauth.attribs.ssl != null){
  extauth.sessionSSL = false;
  
  // Ugh, this deep fudge only works because we know how the RB
  // data-centre handles SSL sites. Will NOT work anywhere else
  // where non https sites are on port != 80
  // What we really need is to have rb.page.env give us access to
  // mod_ssl variables!
  var isSSL = (rb.page.env.ServerPort() != 80);
  
  if (extauth.attribs.ssl.match(/^yes$/i))
    extauth.sessionSSL = true;
}

extauth.authfail   = _rb$extauth_notnull(extauth.attribs.authfail);
extauth.replaceonfail= _rb$extauth_notnull(extauth.attribs.replaceonfail);
//	rb.debug.write("Got ssl attrib : "+extauth.attribs.ssl+", extauth.sessionSSL="+extauth.sessionSSL+" <br>");

if(extauth.sessionSSL == true && enableSSL)
  extauth.postMethod = 'https://';
else
  extauth.postMethod = 'http://';

//	rb.debug.write("In rbm:extauth<br><br>");
//	rb.debug.write("Got authfail page : "+extauth.authfail+"<br>");
//	rb.debug.write("Got replaceonfail page : "+extauth.replaceonfail+"<br>");
if( extauth.replaceonfail != "" )
  extauth.authfail = extauth.replaceonfail;

// Ensure the basic required objects exist.
extauth.sessionData= rb.page.session.read();
if( !extauth.sessionData._rb$login ) {
  extauth.sessionData._rb$login = new Object;
  rb.page.session.write(extauth.sessionData);
}
// Read any session data to discover if we're already logged in.
extauth.sessionUser   = _rb$extauth_notnull(extauth.sessionData._rb$login.User);
extauth.sessionAuth   = extauth.sessionData._rb$login.Auth;
extauth.sessionTime   = extauth.sessionData._rb$login.Time;
extauth.sessionExp    = parseInt(extauth.sessionData._rb$login.Exp);

//	rb.debug.write("Validating sessionUser="+extauth.sessionUser+"<br>");
//	rb.debug.write("Validating sessionComm="+extauth.sessionComm+"<br>");
//	rb.debug.write("Validating sessionAuth="+extauth.sessionAuth+"<br>");
//	rb.debug.write("Validating sessionMand="+extauth.sessionMand+"<br>");

// If we're being asked to check for a different community, we need to check
// that the user in in that community!
if( extauth.sessionUser.length > 0 )
  _rb$extauth_check=_rb$extauth_isin(extauth.sessionUser,extauth.sessionComm);
else
  _rb$extauth_check=null;

if( _rb$extauth_check == null ) {
  extauth.sessionAuth = false;
  //        rb.debug.write("user not in : "+extauth.sessionComm+"<br>");
} else {
  extauth.sessionComm = _rb$extauth_check;
  //        rb.debug.write("using..... sessionComm="+extauth.sessionComm+"<br>");
}

// If login has expired, zap the authorisation so that we fail.
var _rb$extauth_now=(new Date().getTime())/1000;
if( extauth.sessionExp > 0 && _rb$extauth_now-(extauth.sessionExp * 60) > extauth.sessionTime ) {
  extauth.sessionAuth = false;
  //		rb.debug.write("Session expired<br>");
}

// Test for login values OK, or mandatory == "no"
if( (!extauth.sessionAuth || (extauth.sessionSSL && !isSSL && enableSSL)) && extauth.sessionMand.toLowerCase() != "no" ) {

  // FAIL: Not authenticated, and mandatory == "yes"
  // So we remove any session data to be sure we have clean data.
  if( extauth.authfail != "ignore" ) {
    //			rb.debug.write("Authenticate FAIL<br>");
    extauth.sessionData= rb.page.session.read();
    extauth.sessionData._rb$login = new Object;
    extauth.sessionData._rb$login.lastCommunity=extauth.sessionComm;
    rb.page.session.write(extauth.sessionData);
    extauth.sessionUser = null;
    extauth.sessionData = null;
    if( extauth.replaceonfail.length > 0 ) {
      extauth.calldata = rb.page.formdata();
      extauth.calldata.sessionComm = extauth.sessionComm;
      if( _rb$extauth_do_login_from_params() ) {
        _rb$extauth_saferegen(rb.xml.thisTag());
      } else {
        _rb$extauth_if=rb.xml.root.findId("rbm_extinclude")[0];
        rb.page.write(_rb$extauth_if.execute().bodytext());
      }
    } else if( extauth.authfail.length > 0 ) {
      rb.page.redirect(extauth.authfail);
    } else {
      rb.page.write("<h1>Authorisation failed!</h1>");
    }
  } else {
    // authfail="ignore" acts a bit like a login-OK...
    extauth.sessionData = rb.page.session.read();
    extauth.sessionData._rb$login.Time=_rb$extauth_now;
    extauth.sessionData._rb$login.lastCommunity=extauth.sessionComm;
    rb.page.session.write(extauth.sessionData);
  }
} else {
 
  // Authenticatd OK or mandatory="no".
  // So update timeout, store last-used CommunityName and output the body.
  //		rb.debug.write("Authenticate OK<br>");
  if( extauth.sessionAuth == null || extauth.sessionAuth == "" )
    extauth.sessionAuth = false;
  extauth.sessionData = rb.page.session.read();
  extauth.sessionData._rb$login.User=extauth.sessionUser;
  extauth.sessionData._rb$login.Auth=extauth.sessionAuth;
  extauth.sessionData._rb$login.Time= _rb$extauth_now;
  extauth.sessionData._rb$login.lastCommunity=extauth.sessionComm;
  rb.page.session.write(extauth.sessionData);
  extauth.sessionData = null;
  
  _rb$extauth_saferegen(rb.xml.thisTag());
}
extauth=eval(_rb$extauth_array.pop());
//   rb.debug.mode(true);
</rb:macrotag>

<rb:script>
function extlogin(user,pass,comm,expire,ssl) {
	extauth.sessionUser = user;
	extauth.sessionPass = pass;
	extauth.sessionComm = comm == null ? "default" : comm;
	extauth.sessionAuth = false;

	// Ugh, this deep fudge only works because we know how the RB
	// data-centre handles SSL sites. Will NOT work anywhere else
	// where non https sites are on port != 80
	// What we really need is to have rb.page.env give us access to
	// mod_ssl variables!
	var isSSL = (rb.page.env.ServerPort() != 80);

//	rb.debug.write("sessionUser="+extauth.sessionUser+"<br>");
//	rb.debug.write("sessionComm="+extauth.sessionComm+"<br>");

// Test for login values OK.
	if( extauth.sessionPass != null && extauth.sessionUser.length > 0 &&
	    rb.contact.validate(extauth.sessionUser, extauth.sessionPass, extauth.sessionUser) == 1 &&
	    (_rb$extauth_check=_rb$extauth_isin(extauth.sessionUser,
						extauth.sessionComm)) != null &&
	    (ssl == null || !enableSSL || isSSL == ssl)
	    ) {
// Validated the user, and they're in one of the listed
// communities, or OUs.
// ie. Logged in OK, so display stuff from within authok page
//		rb.debug.write("Login OK<br>");
		extauth.sessionComm = _rb$extauth_check;
//		rb.debug.write("using..... sessionComm="+extauth.sessionComm+"<br>");

// Write this back to session... (So go and get the session!)
		extauth.sessionData= rb.page.session.read();
		if( !extauth.sessionData._rb$login )
			extauth.sessionData._rb$login = new Object;

		extauth.sessionData._rb$login.lastCommunity=extauth.sessionComm;
		extauth.sessionData._rb$login.User=extauth.sessionUser;
		extauth.sessionData._rb$login.Exp =parseInt(expire);
		extauth.sessionData._rb$login.Auth=true;
    	extauth.sessionData._rb$login.Time =(new Date().getTime())/1000;
		rb.page.session.write(extauth.sessionData);
		extauth.sessionPass=void 0;
		extauth.sessionAuth=true;
		extauth.sessionData=void 0;
//      rb.debug.mode(true);
		return true;
	} else {
		return false;
	}
}

function _rb$extauth_do_login_from_params() {
// Ensure the basic required objects exist.
	extauth.sessionData= rb.page.session.read();
	if( !extauth.sessionData._rb$login )
		extauth.sessionData._rb$login = new Object;

// Get the parameters passed into the tag.
// and establish defaults where possible.
	extauth.attribs=rb.page.attributes();
	extauth.sessionComm= extauth.attribs.community == null ? "default" :
												extauth.attribs.community;
	extauth.sessionUser= extauth.attribs.user != null ? extauth.attribs.user :
				_rb$extauth_notnull(extauth.sessionData._rb$login.User);
	extauth.sessionPass= extauth.attribs.password;
if(extauth.attribs.ssl != null){
    extauth.sessionSSL = false;

    if(extauth.attribs.ssl.match(/^yes$/i))
	extauth.sessionSSL = true;
}
if(extauth.sessionSSL == true && enableSSL)
    extauth.postMethod = 'https://';
else
    extauth.postMethod = 'http://';

	extauth.authok     = _rb$extauth_notnull(extauth.attribs.authok);
	extauth.sessionData._rb$login.Exp = parseInt(extauth.attribs.expiry);
	extauth.sessionAuth = false;
 
// Get formdata if supplied
	if( extauth.calldata.sessionUser != null && extauth.calldata.sessionUser.length > 0 ) {
		extauth.sessionUser = extauth.calldata.sessionUser;
		extauth.sessionPass = _rb$extauth_notnull(extauth.calldata.sessionPass);
	}
	if( extauth.calldata.sessionComm != null && extauth.calldata.sessionComm.length > 0 ) {
		extauth.sessionComm = _rb$extauth_notnull(extauth.calldata.sessionComm);
	}
	if( extauth.calldata.sessionExp != null ) {
		extauth.sessionData._rb$login.Exp = parseInt(extauth.calldata.sessionExp);
	}
    extauth.sessionData._rb$login.Time =(new Date().getTime())/1000;
    extauth.calldata = void 0;

	return extlogin(extauth.sessionUser,extauth.sessionPass,extauth.sessionComm,extauth.sessionData._rb$login.Exp,extauth.sessionSSL);
}
</rb:script>

<rb:macrotag name="rbm:extlogin">
//   rb.debug.mode(false);

	_rb$extauth_array.push(extauth.toSource());

// Test for login values OK.
	extauth.calldata = rb.page.formdata();
	if( _rb$extauth_do_login_from_params() ){
		if( extauth.authok.length > 0 ) {
			if( extauth.authok != "ignore" )
				rb.page.redirect(extauth.authok);
		} else
			rb.page.write("<h1>Logged in OK.</h1>");
	} else {

// Not-yet logged in, or login failed, so present the body of the tag
// which should collect login data.
//		rb.debug.write("Not-yet logged-in.<br>");
		_rb$extauth_saferegen(rb.xml.thisTag());
	}

	extauth=eval(_rb$extauth_array.pop());
//   rb.debug.mode(true);
</rb:macrotag>

<rb:script>
function extlogout(action) {
// Ensure the basic required objects exist.
	extauth.sessionData= rb.page.session.read();
	if( !extauth.sessionData._rb$login )
		extauth.sessionData._rb$login = new Object;

// Read any session data to discover if we're already logged in.
	extauth.sessionUser = _rb$extauth_notnull(extauth.sessionData._rb$login.User);
	extauth.sessionAuth = extauth.sessionData._rb$login.Auth;
	extauth.sessionTime = extauth.sessionData._rb$login.Time;
	extauth.sessionExp  = parseInt(extauth.sessionData._rb$login.Exp);

// Log out of the currect user/community
// and display the contents of the tag.
	extauth.sessionData._rb$login = new Object;
	extauth.sessionData._rb$login.lastCommunity = "default";
	rb.page.session.write(extauth.sessionData);

	if( typeof(action) == "string" && action == "do_regenerate" ) {
		// Logged out, now display stuff from within login tag.
		_rb$extauth_saferegen(rb.xml.thisTag());
	}
	extauth.sessionPass=void 0;
	extauth.sessionAuth=false;
	extauth.sessionUser="";
}
</rb:script>

<rb:macrotag name="rbm:extlogout">
//   rb.debug.mode(false);
	extlogout("do_regenerate");
//   rb.debug.mode(true);
</rb:macrotag>

<rb:block rb:id="rbm_extinclude">
	<rb:include rb:eval="src#extauth.replaceonfail"/>
</rb:block>
