<!-- Define some form management tags. -->
<rb:script>
   // Create the formset storage.
   var rb$formset = new Array;

   // Take the request name from the parameters.
   var rb$params   = rb.page.formdata()
   var rb$errors   = new Object;
   var rb$command;
   var rb$thisCommand;
   var rb$message  = '';
   var rb$data;
   var rb$doStaticForm;
   var sessionData

   // Utility function that builds a URL. The new URL
   // has all the value parameters from rb$params - with
   // all commands removed (rbcmd-). It also has a number 
   // of additional parameters included from the last parameter.
   function buildURL(base, command, additionalVars) {
      // Merge rb$params into additionalVars;
      for (var i in rb$params) {
        // Strip out all commands.
        if (i.search(/rbcmd-/)<0 && additionalVars[i]==null)
            additionalVars[i]=escape(rb$params[i]);
      }
      // Now - build the URL.
      var url   = base+'?';

      // Add the command.
      url += 'rbcmd-'+command+'=yes';
      for (i in additionalVars) {
        url += '&'+i+'='+additionalVars[i];
      }
      return url;
   }

   // rb$buildFormSet
   // Find all the rbm:command handlers that are children of this tag.
   function rb$buildFormSet(tags) {
   var i;

      cmdTags = tags.find('rbm:command', false);

      for (i=0;i<cmdTags.length;i++) {
        // has a command handler with this name already been registered?
			  var thisCommand = cmdTags[i].attributes.name;
			  if (thisCommand==null)
				  // Can only have one command with the same name!
				  thisCommand = 'default';

			  if (rb$formset[thisCommand]!=null) {
				  rb.debug.error('Duplicate command handler "'+thisCommand+'" in formset');
				  return false;
			  }
        // Thats OK. Check the name.
        if (thisCommand.search(/[^a-zA-Z0-9\-_.]/)>=0) {
				  // name includes illegal characters.
				  rb.debug.error('rbm:command name includes illegal characters: '+thisCommand);
				  return false;
			  }
        // Everything OK - add to the formset.
        rb$formset[thisCommand] = cmdTags[i];
      }
   }
   formsetWantExecute = true
</rb:script>

<rb:macrotag name="rbm:command">
  if (formsetWantExecute)
    rb.xml.thisTag().execute().bodytext()
</rb:macrotag>

<rb:macrotag name="rbm:formset">
// Build the page map.
var tags    = rb.xml.thisTag();
var thisCommand;
var count = 0, i;
var test;

  formsetWantExecute = false;
  rb.xml.thisTag().execute();
  formsetWantExecute = true;


	rb$buildFormSet(tags);

   // Look for a command parameter.
	for (i in rb$params) {
		 if (i.search(/rbcmd-/)>=0) {
			  // Found a command!
			  rb$command = i.slice(6);
		 }
	}
   if (rb$command==null)
		 rb$command = 'default';

   // First step is to see whether the parameters passed to the page tell us which command handler to execute.
   do {
      count++;

	    // See if we have a handler for rb$command
     	thisCommand = rb$formset[rb$command];
      test        = true;

		  if (thisCommand==null) {
        rb$command = 'default';
        if ((thisCommand = rb$formset[rb$command])==null)
           break;
      }

      // Execute this command.
      rb$thisCommand = rb$command;
      
      delete rb$command;
   	  rb$command = null;

	    // Is there a test condition associated with this command?
      if (thisCommand.attributes.test!=null) {
 		    // Yes - has a test. Evaluate it for truth.
        test = eval(thisCommand.attributes.test);
      }
      if (!test) {
         // Can't run page because of an error. Redirect to _either_ the error page _or_ the specified command.
         rb$command = (thisCommand.attributes.error)? thisCommand.attributes.error : 'error';
         rb$message = thisCommand.attributes.msg ? thisCommand.attributes.msg : 'Error executing command';
      }
      else {
         // Got it! Reset the command ID and try to execute the command handler.
         rb.page.write(thisCommand.execute().bodytext());		
      }
   } while (count<5 && rb$command!=null);

	// Write out a client side variable to indicate last command executed		
  if (rb$thisCommand!=null) {
	  rb.page.write('<script language="JavaScript">\n<!--\n');
	  rb.page.write ("var rbthisCommand = "+rb$thisCommand.toSource()+";\n");
	  rb.page.write("//--></script>\n");
  }
</rb:macrotag>

<rb:macrotag name="input" body="atomic">
// Get the name field, which is mandatory. Then check to see with there is an error status against the name.
// the name is defined as 'formset_command_name'.
var attribs = rb.page.attributes();
var errname = attribs.name;
var inError = false;

with (rb.page) {
   if (rb$doStaticForm!=null && rb$doStaticForm==true) {
      // Output just the value part.
      if (rb$data && rb$data[attribs.name]){
         var a = rb$data[attribs.name];
         if(typeof a == "object" && a.constructor == Date)
            write(Util.fmtShortDate(a).bold());
         else
            write(""+a.bold());
      }
      else {
         write(attribs.value==null?'':attribs.value);
      }
   }
   else {
      var tags = rb.xml.thisTag();
      
      tags.execute();
      
      if (errname) {
         inError = (rb$errors[errname]!=null);
         if (inError)
            write('<input class="ErrField" ');
         else
            write('<input ');
         
         // Check to see whether there is a default value for this one.
         if (rb$data && rb$data[errname]!=null){
            var a = rb$data[attribs.name];
            if (attribs.type=="radio") {
              write('value="'+(attribs.value==null?'':attribs.value)+'" ');
              if (attribs.value!=null && a==attribs.value)
                write("checked ");
            }
            else {
              if(typeof a == "object" && a.constructor == Date)
                 write('value="'+Util.fmtShortDate(a)+'" ');
              else
                 write('value="'+a+'" ');
            }
         }
         else
            write('value="'+(attribs.value==null?'':attribs.value)+'" ');
         // Output the rest of the attributes.
         for (var i in attribs) {
            if (i!='value')
               write(i+'="'+attribs[i]+'" ');
         }
         write('>'+(inError ? '*' : ''));
      }
   }
}
</rb:macrotag>

<rb:macrotag name="select">
  // Get the name field, which is mandatory. Then check to see with there is an error status against the name.
	// the name is defined as 'formset_command_name'.
  var inError;

  with (rb.page) {
      var tag = rb.xml.thisTag();

      var errname = tag.attributes.name;
      inError = (rb$errors[errname]!=null);

      write("<select");
      if (inError)
        write(' class="ErrField"');

      for (i in tag.attributes)
        write(' '+i+'="'+tag.attributes[i]+'"');
      write('>'+tag.execute().toString()+'</select>');
  }
</rb:macrotag>

<rb:macrotag name="rbm:pageinfo">
   // Specify the page we want to execute. Has a single 'name' attribute.
   // gets translated into a hidden form handle.
   var attribs = rb.page.attributes();

   // Now add hidden parameters for each of the attributes.
   for (i in attribs) {
      var val = eval(attribs[i]);
      if (val!=null)
        rb.page.write('<input type="hidden" name="'+i+'" value="'+val+'"/>\n');
   }
</rb:macrotag>

<rb:macrotag name="rbm:setReturnUrl">
  // Generate URL to 'this' page and store in session data.
  var url = Util.buildThisURL();
  if (url) {
    if (sessionData==null)
      sessionData = rb.page.session.read();

    sessionData.returnURL = url;
    rb.page.session.write(sessionData);
  }
</rb:macrotag>

<rb:macrotag name="rbm:returnButton">
  var value = rb.page.attribute('value');
  if (value==null)
    value = "Leave";

  if (sessionData==null)
    sessionData = rb.page.session.read();

  if (sessionData.returnURL)
    rb.page.write('<input type="submit" name="namedButton" value="'+value+'" onClick="self.document.location=\''+sessionData.returnURL+'\'; return false;">');
  else
    rb.page.write('<input type="submit" name="namedButton" value="'+value+'" onClick="self.document.location=\'\index.rhtm\'; return false;">');
</rb:macrotag>

<rb:macrotag name="rbm:copyparams">
  // Macro that copies all the input parameters (excluding commands) into hidden fields.
  var params = rb$params;
  var tag     = rb.xml.thisTag();
  var attribs = tag.attributes;
  var copyCommands = (attribs=='yes')

  // Now add hidden parameters for each of the attributes.
  for (i in params) {
    // Is this parameter explicitly excluded?
    if (attribs[i]!='no') {
      // OK to process. Is it a command?
      if (copyCommands || i.search(/rbcmd-/)<0) {
        // NOT a command. Needs to be replicated. Might be an array.
        if (typeof params[i]=="object") {
          // An array. Output each value.
          for (var j=0;i<params[i].length;j++)
            rb.page.write('<input type="hidden" name="'+i+'" value="'+params[i][j]+'"/>\n');
        }
        else 
          // Simple parameter
          rb.page.write('<input type="hidden" name="'+i+'" value="'+params[i]+'"/>\n');
      }
    }
  }
</rb:macrotag>
