/*******************
NewsLetter
********************
Similar to news-item - but when publised is sent to the distribution list
and removed from the author.
********************/
// function NewsLetter(input_data) {Doc.call(this,input_data);}
function NewsLetter(input_data, andContent) {
var restored = false;
var it = null;

   this.customData = {};
   this.privData   = {};
   this.mime       = 'text/html';
   this.state      = 'Draft';
   this.ID         = -1;
   this.category   = -1;         // where it should eventually reside (as well as root).
   this.fileID     = -1;         // Where to find the content for this document.
   this.created    = new Date();
   this.rb$type    = this.docType;
   this.content    = {};

   this.writeAccess  = '';        // Will default to the author before saving.
   this.readAccess   = '';        // this is the default - and means everyone.
   this.assocParents = [];
   this.assocCommunities = [];    // Contact communities we want this stored under.
   this.rb$type    = this.docType;
   
   if (input_data == null)
      input_data = {};
   
   var id       = (input_data.ID == null)?-1:input_data.ID;
   var authorID = (input_data.authorID==null)?-1:input_data.authorID;

   // If there is an ID then try to read this catalogue item.
   if (id>0)
      var it = rb.catalogue.item.get({ID:id, idMkr:'I', allLevels:false});
   else if (authorID>0)
      // Might be under the author - a contact template ID.
      var it = rb.catalogue.item.get({ID:authorID, idMkr:"C", allLevels:false});

   if (it!=null) {
      if (it.getNextRow() && NewsLetter.isInstance(it)) {
         restored = true;

         // If the content is required then read it now.
         this.makeDoc(it);

         if (andContent==null || andContent==true)
            this.getContent();
          for (var p=0;p<Doc.props2.length;p++) {
             if (it[Doc.props2[p].item]!=null)
                this[Doc.props2[p].news] = it[Doc.props2[p].item];
          }
      }
   }
   // Overlay the rb$params parts.
   for (var p in Doc.props3) {
     if (input_data[p])
        this[p] = input_data[p];
   }
   // Deal with assocParent array.
   if (input_data.assocParents!=null) {
     if (typeof input_data.assocParents == 'object')
       this.assocParents = input_data.assocParents;
     else
       this.assocParents = [input_data.assocParents];
   }
}

NewsLetter.prototype = new Doc;
NewsLetter.prototype.docType = Doc.prototype.docType+'/newsletter';

/*****************************************************************
Doc.isInstance
*****************************************************************/
NewsLetter.isInstance = function (catItem) {
   return (catItem.itemData != null && catItem.itemData.rb$type!=null && ((catItem.itemData.rb$type).indexOf(NewsLetter.prototype.docType)==0));
}

/********************************************************************************
NewsLetter.prototype.create
Use the data in the Doc object to create a new category item to represent
the new article. The function returns -1 if it fails. The method checks the size 
of the content and write the content to *either* a file or the stock data area.
********************************************************************************/
NewsLetter.prototype.create = function () {
var item;
var draft = (this.state=='Draft');

   // First of all - create the generic document.
   var ID = this.ID = Doc.prototype.create.call(this);

   if (ID<0)
      return -1;

   // Now link under the generic newsletter location.
   if (!draft && SysData.RootCats.NewsLetters!=null) {
      // Publishing so link to the root of the tree.
      var parent = this.parent;
      if (parent==null)
         parent = SysData.RootCats.NewsLetter;

      // Publish it everywhere it needs to be published.
      this.publish();

      // Newsletters are removed from the authors ownership once published.
      try {rb.contact.unlinkCatItem(this.authorID, this.ID);} catch (ev) {;}
   }
   return this.ID;
}

/********************************************************************************
NewsLetter.prototype.publish
Do a standard publish - but if the state is 'send' then send it to the the
community of recipients and set the state to sent.
********************************************************************************/
Doc.prototype.publish = function() {
  Doc.prototype.publish.call(this);

  // OK - what's the state?
  dumpObj(this,"thisNewsLetter");
}
  
/********************************************************************************
NewsLetter.prototype.save
Save a modified version of this news item. if the generic save of the doc works
check to see whether we're publishing for the first time. If we *are* publishing
then we need to attach to the correct news node. The news node is stored in the
'parentCategory' attribute. If there isn't one then save under the generic
news category.
********************************************************************************/
NewsLetter.prototype.save = function () {
var res     = false;
var publish = (this.state!='Draft');

  if (this.parent==null)
     this.parent = SysData.RootCats.NewsLetter;
  
  return (Doc.prototype.save.call(this));
}

/********************************************************************************
NewsLetterIt - NewsLetter Iterator.
This is a new JavaScript class - it isn't directly instantiated by the application
instead being returned from the Event.get class method. The class 'looks' exactly
like an iterator - but behind the scenes does the manipulation to extract contact
info into the member structure.

Because an iterator is basically a subclass of the basic data structure - with the
addition of the iterator methods. In JavaScript we achieve this simply by setting
the prototype to be an instance of Event.
 ********************************************************************************/
/********************************************************************************
NewsLetterIt
Iterator for NewsLetters information. This is the constructor. Doesn't do anything 
except at the moment.
********************************************************************************/
function NewsLetterIt(catIterator) {
    this.rb$Iterator = catIterator;
}

/********************************************************************************
* Force the iterator to be a subclass of the Event.
*********************************************************************************/
NewsLetterIt.prototype = new NewsLetter;

/********************************************************************************
NewsLetterIt.prototype.getNextRow
Overload for the iterator getNextRow method.
********************************************************************************/
NewsLetterIt.prototype.getNextRow = function () {
var res = false;
   
  do {
    do {
        res = this.rb$Iterator.getNextRow();
     } while (res && !NewsLetter.isInstance(this.rb$Iterator));

     this.makeDoc(this.rb$Iterator);
  } while (res && (this.checkAccess()[test]==false));
   
   // Copy the data from the iterator to 'this'.
   if (res) {
      // Load the member fields from the iterator.
      this.makeDoc(this.rb$Iterator);
   }
   return res;
}
/********************************************************************************
NewsLetter.get
Create an iterator for NewsLetters.
********************************************************************************/
NewsLetter.get = function (data) {
var iterator;
var memIt;

   if (data==null)
      data = {ID:SysData.RootCats.NewsLetter, idMkr:'N', allLevels:1};

   iterator = rb.catalogue.item.get(data);
   newsIt = new NewsLetterIt(iterator);
   return newsIt;
}



