
function rdfGet(uri, expiry){
   // rb.debug.trace(true);
   var FILEOWNER = "rb$rdfGet";
   var text = null;
   var docs = null;
   
   // Default expiry is 1hr;
   if(expiry == null)
      expiry = 60*60*1000;
   var req = null;
   var file = {fileDef:new Binary}
   var data = null;
   
   var iter = rb.file.get({keyword:[uri], searchInDescription:true, sortByOwner:true});
   while(iter.getNextRow()){
      if(iter.owner == FILEOWNER){
         for(var p in iter)
            file[p] = iter[p];
         break;
      }
   }
   
   if(file.fileID != null && file.fileID > 0){
      // rb.debug.write("<h1>String content...</h1>"+file.fileDef.toString());
      try {
         data = file.fileDef.toObj();
      } catch (evObj) {
         data = null;
      }
      if (data) {
         // rb.debug.write("parsing file: "+file.fileID+"<BR>\n");
         if(typeof data == "object" && data.date != null && (((new Date()).getTime() - data.date.getTime()) < expiry)){
            text = data.text;
            docs = data.docs;
            // rb.debug.write("got data "+data.toSource()+"<BR>\n");
         
         }
      }
   }
   if(docs == null){
      if(uri != null && typeof uri == "string"){
         var elements = uri.match(/http:\/\/([^\/]*)(\/.*)/i);
         if(elements.length == 3){
            req = new HttpRequest;
            req.host = elements[1];
            req.path = elements[2];
            req.method = "GET";
            // dumpObj(req, "req");
         }
         
      }
      
      if(req == null)
         return null;
      var res = -1;
      if (rb.page.env.ServerName().indexOf('home.net')>=0)
         res = 200;
      else
         res = req.doRequest();
      
      if(res == 200){
         // rb.debug.write("<h1>Response OK!!!</h1>");

         data = {text:req.toString()};
         data.date = new Date();
         
         // If we didnt get new data, but we have old data, use it anyway...
         if(text == null && data != null)
            text = data.text;
         
         if(text == null)
            return(null);
         
         docs = rdfParse(text);
         data.docs = docs;
         file.fileDef.fromObj(data);
         
         file.name = "cached URL";
         file.description = uri;
         file.owner = "rb$rdfGet";
         
         if(file.fileID != null && file.fileID > 0)
            rb.file.modify(file);
         else
            rb.file.create(file);
         
      }
      else {
         // rb.debug.write("<h1>Request FAILED</h1>\n<p>Response code is : <b>"+res+"</b></p>\n");
         // dumpObj(req);
         ;
      }

   }
   for(var d in docs)
      docs[d].date = data.date;
   
   return(docs);
}

function rdfParse(text){
   // rb.debug.write("parsing text = "+text+"<BR>\n");
   var xml = new XmlParser();
   xml.removeProcInst = true;
   
   var root = xml.build(text);
   // rb.debug.write('tags: '+typeof root+'<br>\n');
   docs = new Array();
   doc  = new Array();

   docs.push(doc);

   root.regenerate();
   
   // Find all the channels.
   var items = root.select("//item");
   var item;
   for(var t = 0; t < items.length; t++){
      var title = items[t].find('title');
      var link = items[t].find('link');
      title = (title.length >0)?title[0].bodytext():"No Title";
      link = (link.length >0)?link[0].bodytext():null;

      doc.push({title:title, link:link});
   }
   //dumpObj(doc, "doc");
   return(docs);
}
