/********************************************************************************
   System data. Stored as an info item underneath the 
   root of the catalogue. This file contains all the
	functions necessary to read and write the system data.

	All the system data is stored in the opaque data area of
	the catalogue itemData field.
********************************************************************************/
var SysName = "System";
var SysDesc = "Site Information - global data.";
var SysData;
var SysId;

// Initialise the system data object. Do this by reading it from the 
// catalogue. If the system data is not stored in the catalogue then
// don't worry at this stage.
var it = rb.catalogue.item.get({idMkr:'N', ID:0, keyword:[SysName], allLevels:0, searchInCode:true});

if (it.getNextRow()) {
   // System data DOES exist - read the meta-data into the object.
	SysData = it.itemData;
	SysId   = it.itemID;
}
else {
   // Doesn't exist - so create the item.
	SysId   = rb.catalogue.item.create({code:SysName, description:SysDesc, itemData:{}});
	SysData = new Object;
}


/********************************************************************************
SysSave
Save the system information. The catalogue item should exist. 
*********************************************************************************/
function SysSave() {
   rb.catalogue.item.modify({itemID:SysId, code:SysName, description:SysDesc, itemData:SysData});
}

