//
// $Id: util.js,v 1.2 2002/02/27 16:48:01 petew Exp $
//
// Some common js functions used on Redbourne websites,
// encapsulated in a Util class
//
//

function Util(){
	var revision = "$Revision: 1.2 $";
	return revision.replace(/\$Revsion: (.*)\$/, "$1");
}

//
// doXmp -- escapes a chunk of XML, used as a replacement for unreliable
//          browser <XMP> tag
//
Util.doXmp = function(xmp_str){
   with(rb.page) {
      var xmp_tab = [
	       ["&", "&amp;"],
   	    ["<", "&lt;"],
	       [">", "&gt;"],
	       ["\n", "<br/>"],
   	    [" ", "&nbsp;"],
	       ];

      var tmpStr = new String(xmp_str);

      for (var seq in xmp_tab){
         var r = new RegExp(xmp_tab[seq][0], "gi");
         tmpStr = tmpStr.replace(r, xmp_tab[seq][1]);
      }
      return(tmpStr);
   }
}

Util.browser = function() {
   var res = {vers:-1, Microsoft:false, Netscape:true};

   var brws = rb.page.env.UserAgent();
   res.Microsoft = (brws!=null &&  brws.indexOf("MSIE") != -1);
   res.Netscape  = (brws!=null &&  brws.indexOf("Netscape")  != -1);
   return res;
}

//
// httpRedirect -- Redirect using an HTTP 303 response to an alternate location
//
// Netscape 4.x does not support 303 redirections, so try sending 302
// instead.
//
// If we can get a Host: header, then use the value we find there as the server
// name to redirect to.
//
Util.httpRedirect = function(uriStr){
  var uri = new String(uriStr);
	var host = rb.page.getHeader("Host");
	var method = (rb.page.env.ServerPort() != 80) ? 'https' : 'http';
	if( host == null )
		host = rb.page.env.ServerName();

	var resp = 303;
	var brws = rb.page.env.UserAgent();
	if( brws.match(/^Mozilla\/4\./) != null )
		resp = 302;

    if(uri != null && uri != ""){
	if(uri.match(/^http:\/\//i) == null)
	    uri = method+"://"+host+rb.page.abspath(uri);
	rb.page.HTTPreturn(resp, "See Also "+uri);
	rb.page.writeheader("Location", uri);

    }
}
Util.buildThisURL = function(extraParams) {
  var url = rb.page.env.Path();
  var tmp;

  tmp = rb.page.env.PathInfo();
  if (tmp)
    url += ('/'+tmp);

  tmp = rb.page.env.QueryString();
  if (tmp) {
    url += ('?'+tmp);
    if (extraParams!=null)
      url += ('&'+extraParams);
  }
  else if (extraParams!=null)
      url += ('?'+extraParams);

  return url;
}


Util.parseDate = function(strparam,locale){
   var months={JAN:1, FEB:2, MAR:3, APR:4, MAY:5, JUN:6, JUL:7,
AUG:8, SEP:9, SEPT:9, OCT:10, NOV:11, DEC:12,
JANUARY:1, FEBRUARY:2, MARCH:3, APRIL:4, JUNE:6,
JULY:7, AUGUST:8, SEPTEMBER:9, OCTOBER:10,
NOVEMBER:11, DECEMBER:12};
   var Mth=0;
   var D=0;
   var Y=0;
   var H=0;
   var Min=0;

   var str = new String(strparam);
   if( !locale || locale == null )
      var locale = rb.page.getHeader("Accept-Language");
   else
      locale = null;
   
   var fmt = str.match(/([a-zA-Z0-9]*)\/([a-zA-Z0-9]*)\/([a-zA-Z0-9]*)\s*(.*)/);
   
   if(fmt == null || fmt.length < 3)
      fmt = str.match(/([a-zA-Z0-9]*)[\s,\.\-]+([a-zA-Z0-9]*)[\s,\.\-]+([a-zA-Z0-9]*)\s*(.*)/);
   
   if(fmt == null)
      return(null);
   
   if(fmt.length == 3)
      fmt[3] = (new Date()).getUTCFullYear();
   
   if(fmt.length < 4)
      return null;
   
   var n = 1;
   if( fmt[n].match(/^[a-zA-Z]*$/) || fmt[++n].match(/^[a-zA-Z]*$/) ){
      var ind = months[fmt[n].toUpperCase()];
      if(ind != null){
         Mth=ind-1;
         D=Number(fmt[n^3]);
      }
      else
         return null;
   }
   else {
      if(locale != null && locale.match(/^en-us/i)){
         Mth=Number(fmt[1])-1;
         D=Number(fmt[2]);
      }
      else{
         D=Number(fmt[1]);
         Mth=Number(fmt[2])-1;
      }
   }
   var Y = parseInt(fmt[3]);
   
   if(Y < 100)
      Y += (Y < 37)? 2000 : 1900;
   
   if(fmt.length >= 5){
      var time = fmt[4].match(/\s*([0-9]*):([0-9]*).*/);
      
      if(time != null && time.length == 3){
         H=Number(time[1]);
         Min=Number(time[2]);
      }
   }
   
   if( isNaN(Y+Mth+D+H+Min) )
      return null;
   
   var res = new Date(Y, Mth, D, H, Min);
   // rb.debug.fwrite("%s %s %s %s %s : %s", Y, Mth, D, H, Min, res);
   return res;
}

Util.fmtShortDate = function(date,locale){
var months=['Jan', 'Feb', 'Mar', 'Apr', 'May', 'June', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

   if( !locale || locale == null )
      var locale = rb.page.getHeader("Accept-Language");
   var ret = "";
   
   if(date == null || typeof date != "object" || date.constructor != Date){
      return null;
   }
   
   // This is pretty basic: US gets mm/dd/yyyy, ROW gets dd/mm/yyyy   
   
   if(locale != null && locale.match(/^en-us/i))
      ret = (months[date.getMonth()])+', '+
      date.getDate()+' '+
      date.getFullYear();
   else
      ret = date.getDate()+' '+
      (months[date.getMonth()])+' '+
      date.getFullYear();
   return(ret);
}
	
Util.fmtShortDateTime = function(date,locale){
  if(date == null || typeof date != "object" || date.constructor != Date){
    return('');
  }
  var ret = Util.fmtShortDate(date,locale);
  
  ret += ' '+date.getHours()+':';
  if(date.getMinutes() <10)
    ret += "0";
  ret += date.getMinutes();
  return(ret);
}

// *******************
// Util.cmpShortDate
// This function compares the day, month and year for the specified
// date pair. The function returns a number as follows:
//    -1:   date1 <  date2
//     0:   date1 == date2
//     1:   date1 >  date2
// *******************
Util.cmpShortDate = function(date1, date2) {
   // First of all - create two two date objects - midnight UTC time
   // on each of the two days.
   var date1 = new Date(date1.valueOf()+4*60*60*1000);
   var date2 = new Date(date2.valueOf()+4*60*60*1000);

   var test1 = new Date(date1.getFullYear(), date1.getMonth(),date1.getDate());
   var test2 = new Date(date2.getFullYear(), date2.getMonth(),date2.getDate());

   // Now do the comparison.
   if (test1.valueOf() < test2.valueOf())
      return -1;
   if (test1.valueOf() > test2.valueOf())
      return 1;
   // Same UTC day
   return 0;
}

Util.nonnull = function(str){
    return((str != null)?str:'');
}

Util.csvwrite = function (data){
	rb.page.writeraw(Util.csvMakeLine(data));
}

Util.csvinit = function (){
	Util._csv_data="";
}

Util.csvadd = function (data){
	Util._csv_data+=Util.csvMakeLine(data);

	// Flush every 32767 bytes...
	if( Util._csv_data.length > 32767 )
		Util.csvsend();
}

Util.csvsend = function (){
	if( Util._csv_data.length )
		rb.page.writeraw( Util._csv_data );
	Util._csv_data="";
}

Util.csvMakeLine =function(data){
   // rb.debug.write("CSV: called to write: "+data.toSource()+"<BR>\n");
	var buf="";
    for(var f = 0; f < data.length; f++){
	var field;
	if(data[f] == null )
		data[f] = "";
	if(typeof data[f] != "string")
	    data[f] = data[f].toString();
	if(data[f].match(/[a-z0-9A-Z#\r\n,]/))
	    field = '"'+data[f].replace(/"/g, '\\"')+'"';
	else
	    field = data[f];
	if(field == null)
		field = "";
	if(f < (data.length - 1))
	    field += ',';
	buf+=field;
    }
    return (buf+'\r\n');
}


Util.copyProp = function(propTable, From, To) {
   for (var p=0;p<propTable.length;p++) {
      if (From[propTable[p]]!=null)
         To[propTable[p]] = From[propTable[p]];
   }
}

Util.CheckClass = function(obj, testClass) {
	if (!(obj instanceof testClass)) {
		dumpObj(obj, "ErrorObject", 4);
      return false;
	}
   return true;
}

// The following method takes a search string (using '*' and '?') and converts it to a template 
// search string using '%' and '_'.
Util.normaliseSearch = function(str) {
  // First of all replace all % and _ in the input string.
  str = str.replace(/[\%\_]/g, ' ');
  // Now replace all * and ?
  str = str.replace(/\*/g,'%');
  str = str.replace(/\?/g,'_');
  return str;
}

// instanceof should be sufficient but fails prior to Whitebeam 0.9.21
// for objects received from a template - and for form params.
Util.isBinary = function(anObj) {
   return (typeof anObj == 'object') && ((anObj instanceof Binary) || (anObj.fromObj != null));
}
