// JavaScript to take the parameters from a profile change and save them in the profile.

// 0. Basic setup
rb$command = 'default'
var rb$message = '';

if (profile.data == null)
  profile.data = {};

// 1. Deal with the simple check-box items.
var options = {name:true, org:true, jobTitle:true, website:true, address:true, phone:true, phone2:true, statement:true};

for (var item in options)
   profile.data[item] = (rb$params[item]=='yes');

// Basics done. Is there an image file?


// Finally the text area.
if (rb$params.file) {
  if (rb$params.file.length>(100*1024))
    rb$message = 'File too big : Maximum file size is <b>100K</b>'
  else if (rb$params.file.length>0)
    profile.storeFile('profile','profile picture','system',rb$params.file,0);
}

var catItem = profile.loadCatItem();

if (rb$params.statementContent) {
  if (rb$params.statementContent.length>4000)
    rb$message = "Your personal statement is too big. This is limited to <b>4000</b> characters";
  else {
    if (catItem)
      catItem.stockData = rb$params.statementContent;
  }
}

// Deal with the skillset.
if (rb$params.skill) {
  var skills;
  if (typeof rb$params.skill == 'object')
    skills = rb$params.skill;
  else
    skills = [rb$params.skill];

  catItem.itemData.skills = {};
  for (var i=0;i<skills.length;i++) {
    rb.debug.write("<h1>Writing code = '"+skills[i]+"'</h1>\n");
    catItem.itemData.skills[skills[i]]=1;
  }

}

// Check the keywords.
if (rb$params.keywords && rb$params.keywords.length > 150)
  rb$params.keywords = (rb$params.keywords).substring(0,149);

catItem.itemData.keywords = (rb$params.keywords?rb$params.keywords:'')

// Finally - does the user want other people to see this profile?
profile.data.publicProfile = (rb$params.publicProfile=='yes');

dumpObj(catItem, "catItem");
// If there were no errors then save the profile.
if (rb$message=='') {
  profile.save();
  // Util.httpRedirect("/user/profile.rhtm")
}
else
  rb$command = 'editProfile';

    
